Name:           jobarranger-manager
Version:        7.0.0
Release:        1%{?dist}
Summary:        Job Arranger Manager.
Vendor:         Daiwa Institute of Research Ltd

Group:		Application/Internet
License:        Apache 2.0
URL:            https://www.jobarranger.info/redmine/
Source: 	%{name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-root

Requires: php-common >= 8.0 php-common < 8.4
Requires: php-cli >= 8.0 php-cli < 8.4
Requires: php-xml >= 8.0 php-xml < 8.4
Requires: php-pdo >= 8.0 php-pdo < 8.4
Requires: php-fpm >= 8.0 php-fpm < 8.4
Requires: php-mbstring >= 8.0 php-mbstring < 8.4
Requires: php-json >= 8.0 php-json < 8.4
Requires: httpd

%description
Job Arranger Manager is a client terminal for editing job nets and checking job operation status.

%prep
%setup0 -q -n %{name}-%{version}

%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/jobarranger/web
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
cp -a %{_builddir}/%{name}-%{version}/jobarranger %{buildroot}/%{_datadir}
install -Dm 0644 -p jam-cleanup.service $RPM_BUILD_ROOT%{_unitdir}/jam-cleanup.service
install -Dm 0644 -p jobarranger-ui.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/jobarranger-ui.conf
install -Dm 0644 -p jobarranger-api.conf $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/jobarranger-api.conf


%clean
rm -rf ${buildroot}

%files
%attr(0755,apache,apache) %{_datadir}/jobarranger
%attr(0755,apache,apache) %{_sysconfdir}/jobarranger/web
%config(noreplace) %{_sysconfdir}/httpd/conf.d/jobarranger-ui.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/jobarranger-api.conf
%{_unitdir}/jam-cleanup.service

%pre
if ! rpm -q 'php-mysqlnd' > /dev/null && \
   ! rpm -q 'php-pgsql' > /dev/null && \
   ! rpm -q 'php8.0-mysqlnd' > /dev/null && \
   ! rpm -q 'php8.1-mysqlnd' > /dev/null && \
   ! rpm -q 'php8.2-mysqlnd' > /dev/null && \
   ! rpm -q 'php8.3-mysqlnd' > /dev/null && \
   ! rpm -q 'php8.0-pgsql' > /dev/null && \
   ! rpm -q 'php8.1-pgsql' > /dev/null && \
   ! rpm -q 'php8.2-pgsql' > /dev/null && \
   ! rpm -q 'php8.3-pgsql' > /dev/null; then
    echo "You need to have either php-mysqlnd or php-pgsql installed (supported versions: 8.0 to 8.3)."
    exit 1
fi

%post
%systemd_post jam-cleanup.service
if [ -f %{_sysconfdir}/jobarranger/web/jam.config.php ]; then
 echo "backup jam.config.php file"
 mv %{_sysconfdir}/jobarranger/web/jam.config.php \
 %{_sysconfdir}/jobarranger/web/jam.config.php.rpmsave
fi

%preun
%systemd_preun jam-cleanup.service
if [ "$1" = "0" ]; then
 if [ -f $RPM_BUILD_ROOT%{_sysconfdir}/jobarranger/web/jam.config.php ]; then
  mv %{_sysconfdir}/jobarranger/web/jam.config.php \
  %{_sysconfdir}/jobarranger/web/jam.config.php.rpmsave
  echo 'warning: /etc/jobarranger/web/jam.config.php saved as /etc/jobarranger/web/jam.config.php.rpmsave' >/dev/stdout;
 fi
fi

%postun
%systemd_postun_with_restart jam-cleanup.service

%changelog
* Fri Oct 11 2024 Copyright Daiwa Institute of Research Ltd. All Rights Reserved. <https://www.jobarranger.info/jaz/jaz_release_note.html> 7.0.0
- Lastest RPM relese